# Class NMR_JmolPanel

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
org.openscience.jmol.app.jmolpanel.JmolPanel
org.openscience.jmol.app.janocchio.NMR_JmolPanel

All Implemented Interfaces:
  `ImageObserver, MenuContainer, Serializable, Accessible, JsonNioClient, SplashInterface`

public class NMR_JmolPanel extends JmolPanel

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`class`
`NMR_JmolPanel.DetachAppletAction`
`class`
`NMR_JmolPanel.JumpBestFrameAction`
`class`
`NMR_JmolPanel.LabelNmrAction`
`class`
`NMR_JmolPanel.ReadNamfisAction`
`class`
`NMR_JmolPanel.ReadNmrAction`
`class`
`NMR_JmolPanel.ReattachAppletAction`
`class`
`NMR_JmolPanel.ViewCoupleTableAction`
`class`
`NMR_JmolPanel.ViewNoeTableAction`
`class`
`NMR_JmolPanel.WriteNamfisAction`

### Nested classes/interfaces inherited from class JmolPanel

`JmolPanel.AboutAction, JmolPanel.ActionChangedListener, JmolPanel.AnimButton, JmolPanel.AppCloser, JmolPanel.CloseAction, JmolPanel.ConsoleAction, JmolPanel.CopyImageAction, JmolPanel.CopyScriptAction, JmolPanel.CreditsAction, JmolPanel.ExecuteScriptAction, JmolPanel.ExitAction, JmolPanel.ExportAction, JmolPanel.GaussianAction, JmolPanel.NewAction, JmolPanel.NewwinAction, JmolPanel.OpenAction, JmolPanel.OpenMolAction, JmolPanel.OpenPdbAction, JmolPanel.OpenUrlAction, JmolPanel.PasteClipboardAction, JmolPanel.PovrayAction, JmolPanel.PrintAction, JmolPanel.RecentFilesAction, JmolPanel.ResizeAction, JmolPanel.ScriptEditorAction, JmolPanel.ScriptWindowAction, JmolPanel.SurfaceToolAction, JmolPanel.ToWebAction, JmolPanel.TwoDEditorAction, JmolPanel.UguideAction, JmolPanel.ViewMeasurementTableAction, JmolPanel.WhatsNewAction, JmolPanel.WriteAction`

### Nested classes/interfaces inherited from class JPanel

`JPanel.AccessibleJPanel`

### Nested classes/interfaces inherited from class JComponent

`JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class Container

`Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

### Nested classes/interfaces inherited from interface JsonNioClient

`JsonNioClient.TouchHandler`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`chemFileProperty`
`CoupleTable`
`coupleTable`
`protected static File`
`currentDir`
`FrameCounter`
`frameCounter`
`FrameDeltaDisplay`
`frameDeltaDisplay`
`protected Map<String,Thread>`
`htMessageCallbacks`
`LabelSetter`
`labelSetter`
`JSplitPane`
`mainSplitPane`
`NoeTable`
`noeTable`
`PopulationDisplay`
`populationDisplay`

### Fields inherited from class JmolPanel

`aboutAction, allowJavaConsole, appletContext, atomSetChooser, atomsetchooserAction, bannerFrame, clientService, closeAction, commands, consoleAction, copyImageAction, copyImageActionProperty, copyScriptAction, copyScriptActionProperty, creditsAction, display, EDITOR_WINDOW_NAME, editorAction, executeScriptAction, exitAction, exportAction, exportActionProperty, FILE_OPEN_WINDOW_NAME, frame, gaussianAction, gaussianDialog, guimap, historyFile, imageType, isPlugin, javaConsoleframe, jmolApp, jmolJME, kioskFrame, measurementTable, menuItems, modelAdapter, myStatusListener, newAction, newwinAction, numWindows, openAction, openmolAction, openpdbAction, openurlAction, OUTSOCKET, pasteClipboardAction, pasteClipboardActionProperty, pcs, pluginFile, povrayAction, povrayActionProperty, preferencesDialog, printAction, printActionProperty, qualityJPG, qualityPNG, recentFiles, recentFilesAction, resizeAction, screenSize, SCRIPT_WINDOW_NAME, splash, startupHeight, startupWidth, status, surfaceTool, SURFACETOOL_WINDOW_NAME, surfaceToolAction, surfaceToolActionProperty, toolbar, toWebAction, toWebActionProperty, twoDEditorAction, twoDEditorActionProperty, uguideAction, viewMeasurementTableAction, vwr, vwrOptions, WEB_MAKER_WINDOW_NAME, whatsnewAction, windowName, writeAction, writeActionProperty`

### Fields inherited from class JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Fields inherited from interface JsonNioClient

`TYPES`

## Constructor Summary

Constructors
Constructor
Description
`NMR_JmolPanel(JmolApp jmolApp, Splash splash, JFrame frame, Jmol parent, int startupWidth, int startupHeight, Map<String,Object> vwrOptions, Point loc)`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`createDisplayAndAddStatusListener()`
`protected GuiMap`
`createGuiMap()`
`protected StatusBar`
`createStatusBar()`
`protected JToolBar`
`createToolBar()`
Create the toolbar.
`protected boolean`
`doClose(boolean saveSize)`
`protected static void`
`dumpContainer(Container c, String s)`
`String`
`getCurrentStructureFile()`
`protected void`
`getDialogs()`
`protected List<Action>`
`getFrameActions()`
`int`
`getFrameAtomCount()`
`protected ImageIcon`
`getIconX(String img)`
`void`
`getJavaConsole()`
`protected void`
`getMeasurementTable()`
`JMenuItem`
`getMenuItem(String name)`
Fetch the menu item that was created for the given command.
`int`
`getMinindex()`
`protected String`
`getStringX(String cmd)`
`static File`
`getUserDirectory()`
Returns a new File referenced by the property 'user.dir', or null if the property is not defined.
`protected String`
`getWindowName()`
`protected void`
`launchMainFrame()`
`void`
`readNmrData(File file)`
`void`
`readNmrDataJSON(File file)`
`protected void`
`saveWindowSizes()`
`protected void`
`setAtomChooser()`
`protected void`
`setFrameLocation(Point loc, JmolPanel parent)`
`protected void`
`setIntoFrame()`
`protected String`
`setMenuKeys(String key, String tokens)`
opportunity to adjust menus for a custom application
`protected void`
`setupConsole()`
`protected void`
`setupDisplay()`
`protected void`
`setupDnD()`
`protected void`
`setupModelAdapterAndViewer()`
`protected static String[]`
`tokenize(String input)`
Take the given string and chop it up into a series of strings on whitespace boundries.
`void`
`writeNmrData(File file)`

### Methods inherited from class JmolPanel

`addHelpMenuBar, addJmolProperties, addJmolProperty, addJmolWindowInfo, addJmolWindowInnerInfo, addMacrosMenu, addNormalMenuBar, addPluginMenu, createMenu, createMenubar, createMenuItem, createToolbarButton, getAction, getAndRegisterPlugin, getConsole, getInstanceWithParams, getJavaConsole, getJmolProperty, getJsonNioServer, getPluginOption, getPreference, isServer, newToolbar, nioClosed, notifyFileOpen, notifyGaussian, notifyGeneralCallback, notifyLanguage, notifyMeasure, notifyMenu, notifyNBO, notifyNBO, notifyPreferences, notifyServer, print, processNioMessage, report, resizeInnerPanel, say, sendNioSyncRequest, serverCycle, setCommandHooks, setMenuState, setPluginOption, setStatus, showStatus, updateConsoleFont`

### Methods inherited from class JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### mainSplitPane

public JSplitPane mainSplitPane

### noeTable

public NoeTable noeTable

### coupleTable

public CoupleTable coupleTable

### frameCounter

public FrameCounter frameCounter

### labelSetter

public LabelSetter labelSetter

### populationDisplay

public PopulationDisplay populationDisplay

### frameDeltaDisplay

public FrameDeltaDisplay frameDeltaDisplay

### currentDir

protected static File currentDir

### chemFileProperty

public static final String chemFileProperty

See Also:
  - Constant Field Values

### htMessageCallbacks

protected Map<String,Thread> htMessageCallbacks

## Constructor Details

### NMR_JmolPanel

public NMR_JmolPanel(JmolApp jmolApp, Splash splash, JFrame frame, Jmol parent, int startupWidth, int startupHeight, Map<String,Object> vwrOptions, Point loc)

## Method Details

### getMenuItem

public JMenuItem getMenuItem(String name)
Description copied from class: `JmolPanel`
Fetch the menu item that was created for the given command.

Overrides:
  `getMenuItem` in class `JmolPanel`
Parameters:
  `name` - Name of the action.
Returns:
  item created for the given command or null if one wasn't created.

### getWindowName

protected String getWindowName()

Overrides:
  `getWindowName` in class `JmolPanel`

### getFrameActions

protected List<Action> getFrameActions()

Overrides:
  `getFrameActions` in class `JmolPanel`
Returns:
  A list of Actions that is understood by the upper level application

### getStringX

protected String getStringX(String cmd)

Overrides:
  `getStringX` in class `JmolPanel`

### getIconX

protected ImageIcon getIconX(String img)

Overrides:
  `getIconX` in class `JmolPanel`

### createGuiMap

protected GuiMap createGuiMap()

Overrides:
  `createGuiMap` in class `JmolPanel`

### createStatusBar

protected StatusBar createStatusBar()

Overrides:
  `createStatusBar` in class `JmolPanel`

### createToolBar

protected JToolBar createToolBar()
Description copied from class: `JmolPanel`
Create the toolbar. By default this reads the resource file for the definition of the toolbars.

Overrides:
  `createToolBar` in class `JmolPanel`
Returns:
  The toolbar

### createDisplayAndAddStatusListener

protected void createDisplayAndAddStatusListener()

Overrides:
  `createDisplayAndAddStatusListener` in class `JmolPanel`

### setupModelAdapterAndViewer

protected void setupModelAdapterAndViewer()

Overrides:
  `setupModelAdapterAndViewer` in class `JmolPanel`

### getDialogs

protected void getDialogs()

Overrides:
  `getDialogs` in class `JmolPanel`

### getMeasurementTable

protected void getMeasurementTable()

Overrides:
  `getMeasurementTable` in class `JmolPanel`

### setupDisplay

protected void setupDisplay()

Overrides:
  `setupDisplay` in class `JmolPanel`

### setFrameLocation

protected void setFrameLocation(Point loc, JmolPanel parent)

Overrides:
  `setFrameLocation` in class `JmolPanel`

### setIntoFrame

protected void setIntoFrame()

Overrides:
  `setIntoFrame` in class `JmolPanel`

### setupConsole

protected void setupConsole()

Overrides:
  `setupConsole` in class `JmolPanel`

### setupDnD

protected void setupDnD()

Overrides:
  `setupDnD` in class `JmolPanel`

### setAtomChooser

protected void setAtomChooser()

Overrides:
  `setAtomChooser` in class `JmolPanel`

### launchMainFrame

protected void launchMainFrame()

Overrides:
  `launchMainFrame` in class `JmolPanel`

### saveWindowSizes

protected void saveWindowSizes()

Overrides:
  `saveWindowSizes` in class `JmolPanel`

### getJavaConsole

public void getJavaConsole()

Overrides:
  `getJavaConsole` in class `JmolPanel`

### setMenuKeys

protected String setMenuKeys(String key, String tokens)
Description copied from class: `JmolPanel`
opportunity to adjust menus for a custom application

Overrides:
  `setMenuKeys` in class `JmolPanel`
Parameters:
  `key` -
  `tokens` -
Returns:
  possibly changed token string

### doClose

protected boolean doClose(boolean saveSize)

Overrides:
  `doClose` in class `JmolPanel`

### getMinindex

public int getMinindex()

### getCurrentStructureFile

public String getCurrentStructureFile()

### getUserDirectory

public static File getUserDirectory()
Returns a new File referenced by the property 'user.dir', or null if the property is not defined.

Returns:
  a File to the user directory

### dumpContainer

protected static void dumpContainer(Container c, String s)

### tokenize

protected static String[] tokenize(String input)
Take the given string and chop it up into a series of strings on whitespace boundries. This is useful for trying to get an array of strings out of the resource file.

Parameters:
  `input` - String to chop
Returns:
  Strings chopped on whitespace boundries

### writeNmrData

public void writeNmrData(File file) throws IOException

Throws:
  `IOException`

### readNmrData

public void readNmrData(File file) throws Exception

Throws:
  `Exception`

### readNmrDataJSON

public void readNmrDataJSON(File file) throws Exception

Throws:
  `Exception`

### getFrameAtomCount

public int getFrameAtomCount()